﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Data;
using System.Data.SqlClient;

namespace DataGridView_ComboBox_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private const string ConnectionString = @"Data Source=.\SQL2017;Initial Catalog=AjaxSamples;Integrated Security = true";
        private void Form1_Load(object sender, EventArgs e)
        {
            //Fetch the data from Database.
            dataGridView1.DataSource = this.GetData("SELECT CustomerId, Name FROM Customers");
            dataGridView1.AllowUserToAddRows = false;

            //Add a ComboBox Column to the DataGridView.
            DataGridViewComboBoxColumn comboBoxColumn = new DataGridViewComboBoxColumn();
            comboBoxColumn.HeaderText = "Country";
            comboBoxColumn.Width = 100;
            comboBoxColumn.Name = "comboBoxColumn";
            dataGridView1.Columns.Add(comboBoxColumn);

            //Loop through the DataGridView Rows.
            foreach (DataGridViewRow row in dataGridView1.Rows)
            {
                //Reference the ComboBoxCell.
                DataGridViewComboBoxCell comboBoxCell = (row.Cells[2] as DataGridViewComboBoxCell);

                //Insert the Default Item to ComboBoxCell.
                comboBoxCell.Items.Add("Select Country");

                //Set the Default Value as the Selected Value.
                comboBoxCell.Value = "Select Country";

                //Fetch the Countries from Database.
                DataTable dt = this.GetData("SELECT CustomerId,  Country from Customers");

                //Loop through the DataTable Rows.
                foreach (DataRow drow in dt.Rows)
                {
                    //Fetch the CustomerId (Primary Key) value.
                    string customerId = drow[0].ToString();

                    //Add the Country value to the ComboBoxCell.
                    comboBoxCell.Items.Add(drow[1]);

                    //Except for CustomerId #3.
                    if (customerId != "3")
                    {
                        //Compare the value of CustomerId.
                        if (row.Cells[0].Value.ToString() == customerId)
                        {
                            //Once CustomerId is matched, select the Country in ComboBoxCell
                            comboBoxCell.Value = drow[1];
                        }
                    }
                }
            }
        }

        private DataTable GetData(string sql)
        {
            using (SqlConnection con = new SqlConnection(ConnectionString))
            {
                using (SqlCommand cmd = new SqlCommand(sql, con))
                {
                    cmd.CommandType = CommandType.Text;
                    using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                    {
                        using (DataTable dt = new DataTable())
                        {
                            sda.Fill(dt);
                            return dt;
                        }
                    }
                }
            }
        }
    }
}
